
; ATmega46

; Fuse-Bits fr Mega16:
; Quarz

; 30.05.2009 M'Soft Berlin

; 29.06.2009 FW 0.8
; etwas aufgerumt...
; einstellbare Bufferlnge eingebaut

.equ	HW_VER		= '1'
.equ	HW_REV		= '1'

.equ	FW_VER		= '1'
.equ	FW_REV		= '0'

.include "m16def.inc"

.include "Definitionen.inc"

;****************************** Verktor-Liste ****************************

.CSEG
		rjmp    Reset

.ORG	URXCaddr
		rjmp	irq_rx						; fr Break-Funktion

;****************************** Programm-Beginn **********************

.ORG	INT_VECTORS_SIZE
 
;*********************************************************************
;  Initialisierungsroutine
;*********************************************************************

; Hardware initialisieren

Reset:
	  ldi     TEMP_0,low(RAMEND)          ; Stack an das interne Ram-Ende
	  out     SPL,TEMP_0
    ldi     TEMP_0,high(RAMEND)
    out     SPH,TEMP_0

; Port A *************************************************************

		ser		TEMP_0						; alles H
		out		PORTA,TEMP_0
		ser		TEMP_0						; alles Ausgang
		out		DDRA,TEMP_0

; Port B *************************************************************

		ser		TEMP_0						; alles Eingnge mit PullUp
		out		PORTB,TEMP_0
		clr		TEMP_0						; alles Eingang
		out		DDRB,TEMP_0

; Port C *************************************************************

		ser		TEMP_0						; alles H
		out		PORTC,TEMP_0
		ser		TEMP_0						; alles Ausgang
		out		DDRC,TEMP_0
	
; Port D *************************************************************
		
		ldi		TEMP_0,~((1<<C_CLOCK) | (1<<MUX_A) | (1<<MUX_B))
		out		PORTD,TEMP_0				; Ram lesen, Buffer TriState, Takt H ( /WE inaktiv)
		ldi		TEMP_0,(1<<C_SAMPLE) | (1<<C_BUFFER) | (1<<C_CLOCK) | (1<<MUX_A) | (1<<MUX_B)
		out		DDRD,TEMP_0			

; UART ***************************************************************

		ldi   TEMP_0,high(UART_BAUD_SELECT)
    out   UBRRH,TEMP_0
    ldi   TEMP_0,low(UART_BAUD_SELECT)
    out   UBRRL,TEMP_0

		ldi   TEMP_0,(1<<U2X)
		out	  UCSRA,TEMP_0

    ldi   TEMP_0,(1<<TXEN) | (1<<RXEN) | (1<<RXCIE)
    out   UCSRB,TEMP_0

    ldi   TEMP_0,(1<<URSEL) | (1<<UCSZ1) | (1<<UCSZ0)
    out   UCSRC,TEMP_0
 
;*********************************************************************				 

; Software initialisieren

		clr		NULL

    load_p  Y,4096              ; Ramgre
   	sts		BUF_LEN_L,YL
		sts		BUF_LEN_H,YH

;*********************************************************************
;  Main-Loop
;*********************************************************************

main:					
		rcall	uart_receive_byte			; 7 Mode
		cpi		TEMP_0,CMD_RESTART		; Command-Byte?
		breq	main  								; ja

		mov		MODE,TEMP_0

		rcall	uart_receive_byte			; 1 Triggerbyte
		mov		TRIG_BYTE,TEMP_0

		rcall	uart_receive_byte			; 2 Triggermaske
		mov		TRIG_MASK,TEMP_0

		rcall	uart_receive_byte			; 3 Timerintervall
		cpi		TEMP_0,CMD_RESTART		; Reset-Byte?
		breq	main									; ja

		mov		TIMER_WERT,TEMP_0
			
		rcall	uart_receive_byte			; 5 Pretrigger
		cpi		TEMP_0,CMD_RESTART		; Reset-Byte?
		breq	main									; ja

		mov		PRE_TRIGGER,TEMP_0

		rcall	uart_receive_byte			; 6 zustzliches 1. LS164

		rcall	uart_receive_byte			; 7 zustzliches 2. LS164

		cpi		MODE,MODE_MAX					; ungltiger Mode
		brsh	main

		load_p	Z,(2*tab_funktion)
		lsl		MODE
		add		ZL,MODE
		adc		ZH,NULL
		lpm		YL,Z+									; Funtionsadresse holen
		lpm		YH,Z
		mov		ZL,YL									; und nach Z fr ICALL
		mov		ZH,YH

		icall

		cpi   MODE,10
    brlo  main

		rcall	send_daten

		rjmp	main

;*********************************************************************

irq_rx:
		in		SREG_SAVE,SREG

		lds		YL,UDR0								; Byte abholen

		ldi		YL,1									; Restzhler auf Minimum
		ldi		YH,0

		sbr		SREG_SAVE,(1<<SREG_T)

		out		SREG,SREG_SAVE

		reti

;*********************************************************************

.include "Subroutinen.inc"
.include "Tabellen.inc"

